import com.entrouvert.cryptic.*;

class Myclass{
    public static void main(String[] arg){
	//System.out.println(System.getProperty("java.library.path")); 

	System.out.println("\n\t############## JAVA TESTS ##############\n");

	test_1();
	test_2();
    }

    private static void test_1(){
	System.out.println("\n\t############## TEST 1 ##############\n");

	String[] quantities = { "1234567890c", "1234567890b", "1234567890a", };

	System.out.println("Group generation...");
	PrimeOrderGroup g = new PrimeOrderGroup(256);
	g.moreBases(5);
	String[] bases = (String[]) g.getbases();
	int i;
	for(i=0;i<5;i++){
		System.out.println("Base: " + bases[i]);
	}
	System.out.println("Group generation successful.");

	System.out.println("Prover: DLREP to prove generation...");
	String dlrep = CrypticJNI.get_dlrep(3,quantities,bases,g.getp());
	System.out.println("DLREP: " + dlrep);

	System.out.println("Prover: Proof round1");
	ZkpkSchnorr s = new ZkpkSchnorr(g.getbases(),3,g.getp());
	s.round1();
	System.out.println("Prover: Send DLREP: " + dlrep);
	System.out.println("Prover: Send commitments.");

	String challenge = CrypticJNI.ret_random(80);
	System.out.println("Verifier: Send challenge: " + challenge);

	System.out.println("Prover: Proof round2");
	s.round2(g.getorder(),challenge,quantities);
	System.out.println("Prover: Send responses.");


	ZkpkSchnorr s2 = new ZkpkSchnorr(g.getbases(),3,g.getp());
	int rc = s2.verifyInteractiveProof(dlrep,s.getcommitment(),challenge,s.getresponses());
	System.out.println("Verifier: Proof verification: " + rc);
   }

    private static void test_2(){
	System.out.println("\n\t############## TEST 2 ##############\n");

	System.out.println("QRG generation...");
	QRG qrg = new QRG(1024);
	System.out.println("QRG generated");
	System.out.println("qrg.getp() : " + qrg.getp());
	System.out.println("qrg.getn() : " + qrg.getn());
	System.out.println("qrg.getbase() : " + qrg.getbase());
	QRG qrg2 = QRG.newLoad(qrg.getp(), qrg.getn(), qrg.getbase());
	//QRG qrg2 = new QRG(qrg.getp(), qrg.getn(), qrg.getbase());

	System.out.println("Clsig server generation...");
	Clsig c = new Clsig(1024,256,600,0,0,0,10);
	c.generateParameters();
	System.out.println("Clsig server generated.");

	Clsig c2;
	c2 = Clsig.newLoadPublicParameters(c.getz(),c.gets(),10,c.getbases(),c.getlgQuantities(),c.getlgExponent(),c.getmodulus(),c.getlgSecParam(),c.getlgZkSecParam(),c.getlgClsigSecParam());
	//Clsig c2 = new Clsig(c.getz(),c.gets(),10,c.getbases(),c.getlgQuantities(),c.getlgExponent(),c.getmodulus(),c.getlgSecParam(),c.getlgZkSecParam(),c.getlgClsigSecParam());

	String qa = CrypticJNI.char_to_bn("Kirk");
	String qb = CrypticJNI.char_to_bn("Captain");
	String[] tab_q = {qa, qb};
	CommitDataStore pdc = new CommitDataStore();
	String[] tab_b = {(String)c2.getbases()[1],(String)c2.getbases()[5]};

	c2.computeCommittedValue(pdc,tab_b,tab_q,2);

/*q1 = cryptic.charToBn("Mik")
q2 = cryptic.charToBn("Ates")
q3 = cryptic.charToBn("Clermont-Fd")
q4 = cryptic.intToBn(1982280100)
c.computeDlrepByIndex((q1,q2,q3,q4),(0,2,3,4),4)
c.signWithCommittedValue(pdc.dlrep)
c.verifySignatureNotRandomized()
c2.loadCertificateWithIndexWithCommittedValue(c.a,c.e,c.v,c.quantities,4,(qa,qb),2,pdc.dlrep,pdc.vprime,(0,2,3,4))
c2.randomizeSignature()
c2.verifySignatureRandomized()
dlrep = c2.buildDlrepBeforeProving((1,),(2,),1)
fixed_add_size = c2.lgZkSecParam + c2.lgQuantities
r0 = cryptic.retRandom(c2.intervalExponent + fixed_add_size)
r1 = cryptic.retRandom(c2.lgBlind + fixed_add_size)
r2 = cryptic.retRandom(c2.lgQuantities + fixed_add_size)
r3 = cryptic.retRandom(c2.lgQuantities + fixed_add_size)
r4 = cryptic.retRandom(c2.lgQuantities + fixed_add_size)
r5 = cryptic.retRandom(c2.lgQuantities + fixed_add_size)
r6 = cryptic.retRandom(c2.lgQuantities + fixed_add_size)
s = cryptic.ZkpkSchnorr((c2.aRand,c2.s,c2.bases[0],c2.bases[3],c2.bases[4],c2.bases[1],c2.bases[5]),7,c2.modulus)
s.round1RandomsChosen((r0,r1,r2,r3,r4,r5,r6))
pr = cryptic.ProofrangeQrg(c2.s,c2.z,c2.modulus)
b = cryptic.intToBn(1992040400)
pr.round1(cryptic.PROOF_RANGE_LT,q4,b,s.randoms[4],c2.lgSecParam,c2.lgZkSecParam,256)
h = cryptic.HashForNiProofs(256)
h.addProof(s,dlrep)
h.addProofrangeProver(pr)
h.computeHash()
s.round2WithoutOrder(h.hValue,(c2.eCorrected,c2.vRand,q1,q3,q4,qa,qb))
pr.round2(h.hValue)
c3 = cryptic.Clsig.newLoadPublicParameters(c.z,c.s,10,c.bases,c.lgQuantities,c.lgExponent,c.modulus,c.lgSecParam,c.lgZkSecParam,c.lgClsigSecParam)
s2 = cryptic.ZkpkSchnorr((c2.aRand,c3.s,c3.bases[0],c3.bases[3],c3.bases[4],c2.bases[1],c2.bases[5]),7,c3.modulus)
s2.verifyNoninteractiveProof(dlrep,h.hValue,s.responses)
pr2 = cryptic.ProofrangeQrg(c3.s,c3.z,c3.modulus)
pr2.verifyNoninteractiveProof(cryptic.PROOF_RANGE_LT,b,pr.dlreps,h.hValue,pr.responses)
h2 = cryptic.HashForNiProofs(256)
h2.addProof(s2,dlrep)
h2.addProofrangeVerifier(pr2,pr.dlreps)
h2.computeHash()
cryptic.cmpBn(h.hValue,h2.hValue)*/

   }

}

